Kea: isc::lease_cmds::Lease6Parser Class Reference

| Kea 2.2.0

Public Member Functions | List of all members
isc::lease_cmds::Lease6Parser Class Reference

Parser for Lease6 structure. More...

`#include <lease_parser.h>`

Inheritance diagram for isc::lease_cmds::Lease6Parser:
[legend]

## Public Member Functions
virtual | ~Lease6Parser ()
| virtual dtor (does nothing) More...
virtual isc::dhcp::Lease6Ptr | parse (isc::dhcp::ConstSrvConfigPtr &cfg, const isc::data::ConstElementPtr &lease_info, bool &force_create)
| Parses Element tree and tries to convert to Lease4. More...
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t. More...
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t. More...
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value. More...
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet. More...

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type. More...
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present. More...
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child. More...
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope. More...
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope. More...
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range. More...
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element. More...
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope. More...
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values. More...
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list. More...
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type , target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope. More...
template<typename int_type >
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope. More...

## Detailed Description

Parser for Lease6 structure.

{ "address": "2001:db8::1", "duid": "00:01:02:03:04:05", "type": "IA_NA", "cltt": 12345678, "preferred-lft": 3600, "valid-lft": 3600, "expire": 1499282530, "subnet-id": 1, "fqdn-fwd": true, "fqdn-rev": true, "hostname": "myhost.example.org", "state": 0, "user-context": { "version": 1 } } It expects the input data to use the following format:

Definition at line 76 of file lease_parser.h.

## Constructor & Destructor Documentation

## ◆ ~Lease6Parser()

virtual isc::lease_cmds::Lease6Parser::~Lease6Parser | ( |  | ) |
| inlinevirtual

virtual dtor (does nothing)

Definition at line 94 of file lease_parser.h.

## Member Function Documentation

## ◆ parse()

Lease6Ptr isc::lease_cmds::Lease6Parser::parse | ( | isc::dhcp::ConstSrvConfigPtr & | cfg,
|  | const isc::data::ConstElementPtr & | lease_info,
|  | bool & | force_create
| ) |  |
| virtual

Parses Element tree and tries to convert to Lease4.

See Lease6Parser class description for expected format.

Parameters

  | cfg | Currently running config (used for sanity checks and defaults)
  | lease_info | structure to be parsed
  [out] | force_create | indicates if the lease should be created when it doesn't exist.

Returns
  A pointer to Lease4

Exceptions

  BadValue | if any of the parameters is invalid
  DhcpConfigError | if mandatory parameter is missing

Let's calculate client last transmission time (cltt). If expiration timestamp is specified explicitly, we will use that. Note there are no checks whether this is in the past. There may be valid cases when user wants to insert expired leases, e.g. when migrating from one DHCP server to another and wants to migrate the database as is, without discarding any leases.

Definition at line 183 of file lease_parser.cc.

References isc::data::copy(), isc::data::SimpleParser::getAddress(), isc::data::SimpleParser::getBoolean(), isc::data::SimpleParser::getInteger(), isc::data::SimpleParser::getString(), isc::data::SimpleParser::getUint32(), isc::data::SimpleParser::getUint8(), isc_throw, isc::asiolink::IOAddress::isV4(), and isc::asiolink::IOAddress::toText().

Referenced by isc::lease_cmds::LeaseCmdsImpl::lease6BulkApplyHandler(), isc::lease_cmds::LeaseCmdsImpl::lease6UpdateHandler(), and isc::lease_cmds::LeaseCmdsImpl::leaseAddHandler().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- lease_parser.h
- lease_parser.cc